﻿Public Class frmCalculator

    Dim DecimalButtonClicked As New Boolean
    Dim PercentageButtonClicked As New Boolean
    Dim InputStatus As New Boolean
    Dim ClearCalc As New Boolean
    Dim OperandHolder1 As Double
    Dim OperandHolder2 As Double
    Dim CurrentNumber As New Double
    Dim Memory As New Double
    Dim CurrentFunction As String

    Private Sub frmCalculator_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        DecimalButtonClicked = 0
        PercentageButtonClicked = 0
    End Sub

    Private Sub CalculateTotals()
        OperandHolder2 = CDbl(txtCalcEntryResult.Text)
        Select Case CurrentFunction
            Case "Add"
                OperandHolder1 = OperandHolder1 + OperandHolder2
            Case "Subtract"
                OperandHolder1 = OperandHolder1 - OperandHolder2
            Case "Divide"
                OperandHolder1 = OperandHolder1 / OperandHolder2
            Case "Multiply"
                OperandHolder1 = OperandHolder1 * OperandHolder2
            Case "PowerOf"
                OperandHolder1 = System.Math.Pow(OperandHolder1, OperandHolder2)
        End Select
        txtCalcEntryResult.Text = CStr(OperandHolder1)
        InputStatus = True
    End Sub

#Region "Number buttons"

    Private Sub btn0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn0.Click
        If InputStatus = False Then
            If txtCalcEntryResult.Text.Length >= 1 Then
                txtCalcEntryResult.Text += btn0.Text
            End If
        End If
    End Sub

    Private Sub btnDecimal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDecimal.Click
        If DecimalButtonClicked = 0 Then
            DecimalButtonClicked = 1
            txtCalcEntryResult.Text = txtCalcEntryResult.Text & "."
        Else
            MsgBox("Error: You can only have one decimal point in a single calculation.", MsgBoxStyle.Critical, "Error")
        End If
    End Sub


    Private Sub btn1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn1.Click
        If InputStatus = False Then
            txtCalcEntryResult.Text += btn1.Text
        Else
            txtCalcEntryResult.Text = btn1.Text
            InputStatus = False
        End If
    End Sub

    Private Sub btn2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn2.Click
        If InputStatus = False Then
            txtCalcEntryResult.Text += btn2.Text
        Else
            txtCalcEntryResult.Text = btn2.Text
            InputStatus = False
        End If
    End Sub

    Private Sub btn3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn3.Click
        If InputStatus = False Then
            txtCalcEntryResult.Text += btn3.Text
        Else
            txtCalcEntryResult.Text = btn3.Text
            InputStatus = False
        End If
    End Sub

    Private Sub btn4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn4.Click
        If InputStatus = False Then
            txtCalcEntryResult.Text += btn4.Text
        Else
            txtCalcEntryResult.Text = btn4.Text
            InputStatus = False
        End If
    End Sub

    Private Sub btn5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn5.Click
        If InputStatus = False Then
            txtCalcEntryResult.Text += btn5.Text
        Else
            txtCalcEntryResult.Text = btn5.Text
            InputStatus = False
        End If
    End Sub

    Private Sub btn6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn6.Click
        If InputStatus = False Then
            txtCalcEntryResult.Text += btn6.Text
        Else
            txtCalcEntryResult.Text = btn6.Text
            InputStatus = False
        End If
    End Sub

    Private Sub btn7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn7.Click
        If InputStatus = False Then
            txtCalcEntryResult.Text += btn7.Text
        Else
            txtCalcEntryResult.Text = btn7.Text
            InputStatus = False
        End If
    End Sub

    Private Sub btn8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn8.Click
        If InputStatus = False Then
            txtCalcEntryResult.Text += btn8.Text
        Else
            txtCalcEntryResult.Text = btn8.Text
            InputStatus = False
        End If
    End Sub

    Private Sub btn9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn9.Click
        If InputStatus = False Then
            txtCalcEntryResult.Text += btn9.Text
        Else
            txtCalcEntryResult.Text = btn9.Text
            InputStatus = False
        End If
    End Sub

    Private Sub btn10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn10.Click
        If InputStatus = False Then
            txtCalcEntryResult.Text += btn10.Text
        Else
            txtCalcEntryResult.Text = btn10.Text
            InputStatus = False
        End If
    End Sub

#End Region

#Region "Operation Buttons"

    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        If txtCalcEntryResult.Text.Length <> 0 Then
            If CurrentFunction = String.Empty Then
                OperandHolder1 = CDbl(txtCalcEntryResult.Text)
                txtCalcEntryResult.Text = String.Empty
            Else
                CalculateTotals()
            End If
            CurrentFunction = "Add"
            DecimalButtonClicked = False
        End If
    End Sub

    Private Sub btnSubtract_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSubtract.Click
        If txtCalcEntryResult.Text.Length <> 0 Then
            If CurrentFunction = String.Empty Then
                OperandHolder1 = CDbl(txtCalcEntryResult.Text)
                txtCalcEntryResult.Text = String.Empty
            Else
                CalculateTotals()
            End If
            CurrentFunction = "Subtract"
            DecimalButtonClicked = False
        End If
    End Sub

    Private Sub btnMultiply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMultiply.Click
        If txtCalcEntryResult.Text.Length <> 0 Then
            If CurrentFunction = String.Empty Then
                OperandHolder1 = CDbl(txtCalcEntryResult.Text)
                txtCalcEntryResult.Text = String.Empty
            Else
                CalculateTotals()
            End If
            CurrentFunction = "Multiply"
            DecimalButtonClicked = False
        End If
    End Sub

    Private Sub btnDivide_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDivide.Click
        If txtCalcEntryResult.Text.Length <> 0 Then
            If CurrentFunction = String.Empty Then
                OperandHolder1 = CDbl(txtCalcEntryResult.Text)
                txtCalcEntryResult.Text = String.Empty
            Else
                CalculateTotals()
            End If
            CurrentFunction = "Divide"
            DecimalButtonClicked = False
        End If
    End Sub

    Private Sub btnEquals_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEquals.Click
        If txtCalcEntryResult.Text.Length <> 0 AndAlso OperandHolder1 <> 0 Then
            CalculateTotals()
            CurrentFunction = ""
            DecimalButtonClicked = False
        End If
    End Sub

#End Region

#Region "Clear Buttons"

    Private Sub btnClearLast_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearLast.Click
        txtCalcEntryResult.Text = String.Empty
        DecimalButtonClicked = False
    End Sub

    Private Sub btnClearAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearAll.Click
        txtCalcEntryResult.Text = String.Empty
        OperandHolder1 = 0
        OperandHolder2 = 0
        CurrentFunction = String.Empty
        DecimalButtonClicked = False
    End Sub

#End Region

#Region "Special Functions"

    Private Sub btnSquare_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSquare.Click
        If txtCalcEntryResult.Text.Length <> 0 Then
            If CurrentFunction = String.Empty Then
                OperandHolder2 = CDbl(txtCalcEntryResult.Text)
                txtCalcEntryResult.Text = String.Empty
            Else
                CalculateTotals()
            End If
            CurrentFunction = "PowerOf"
            DecimalButtonClicked = False
        End If
    End Sub

    Private Sub btnSquareRoot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSquareRoot.Click
        If txtCalcEntryResult.Text.Length <> 0 Then
            Memory = CDbl(txtCalcEntryResult.Text)
            Memory = System.Math.Sqrt(Memory)
            txtCalcEntryResult.Text = CStr(Memory)
            DecimalButtonClicked = False
        End If
    End Sub

    Private Sub btnSignSwitch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSignSwitch.Click
        If InputStatus = False Then
            If txtCalcEntryResult.Text.Length > 0 Then
                OperandHolder1 = -1 * CDbl(txtCalcEntryResult.Text)
                txtCalcEntryResult.Text = CStr(OperandHolder1)
            End If
        End If
    End Sub

    Private Sub btnInverse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInverse.Click
        If txtCalcEntryResult.Text.Length <> 0 Then
            Memory = CDbl(txtCalcEntryResult.Text)
            Memory = 1 / Memory
            txtCalcEntryResult.Text = CStr(Memory)
            DecimalButtonClicked = False
        End If
    End Sub

#End Region

    Private Sub btnBackspace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBackspace.Click
        Dim str As String
        Dim loc As Integer
        If txtCalcEntryResult.Text.Length > 0 Then
            str = txtCalcEntryResult.Text.Chars(txtCalcEntryResult.Text.Length - 1)
            If str = "." Then
                DecimalButtonClicked = False
            End If
            loc = txtCalcEntryResult.Text.Length
            txtCalcEntryResult.Text = txtCalcEntryResult.Text.Remove(loc - 1, 1)
        End If
    End Sub
End Class
